﻿'use strict';

var help = {};
(function (hlp) {

    hlp.curAnim = 0;
    hlp.animating = true;
    hlp.cancel = false;
    hlp.anims = undefined;
    hlp.rowHeight = undefined;
    hlp.firstRowTop = undefined;
    hlp.lastRowTop = undefined;

    hlp.initAnims = function () {

        hlp.anims = [
            {
                constr: [
                    { class: 'tblcell', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'txt-1-1', attr: 'visibility', val: 'visible', delay: 400 },
                    { id: 'tbl-0-0', attr: 'visibility', val: 'visible', delay: 1000 },
                    { id: 'tbl-0-1', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'tbl-0-2', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'tbl-1-0', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'tbl-1-1', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'tbl-1-2', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'tbl-2-0', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'tbl-2-1', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'tbl-2-2', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'tbl-3-0', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'tbl-3-1', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'tbl-3-2', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'txt-1-1', attr: 'visibility', val: 'hidden', delay: 500 },
                    { id: 'txt-1-2', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'smbl-0', attr: 'visibility', val: 'visible', delay: 1000 },
                    { id: 'smbl-1', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'smbl-2', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'smbl-3', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'smbl-4', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'smbl-5', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'smbl-6', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'smbl-7', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'smbl-8', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'smbl-9', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'smbl-10', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'smbl-11', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'smbl-12', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'smbl-13', attr: 'visibility', val: 'visible', delay: 100 },
                    { id: 'txt-0', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'txt-1-2', attr: 'visibility', val: 'hidden', delay: 1000 }
                ],
                destr: [
                    { class: 'tblcell', attr: 'visibility', val: 'visible', delay: 0 },
                    { class: 'smbl', attr: 'visibility', val: 'visible', delay: 0 },
                    { id: 'txt-1-1', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'txt-1-2', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'txt-0', attr: 'visibility', val: 'visible', delay: 500 }
                ]
            },
            {
                constr: [
                    { id: 'txt-2', attr: 'visibility', val: 'visible', delay: 400 },
                    { id: 'tbl-1-1', attr: 'fill', val: 'crimson', delay: 1000 },
                    { id: 'tbl-1-0', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-1-2', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'smbl-6', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-1-1', attr: 'fill', val: 'white', delay: 500 },
                    { id: 'tbl-1-0', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-1-2', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'smbl-6', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-1-1', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-1-0', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-1-2', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'smbl-6', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-1-1', attr: 'fill', val: 'white', delay: 500 },
                    { id: 'tbl-1-0', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-1-2', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'smbl-6', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-1-1', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-1-0', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-1-2', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'smbl-6', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-1-1', attr: 'fill', val: 'white', delay: 500 },
                    { id: 'tbl-1-0', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-1-2', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'smbl-6', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'txt-2', attr: 'visibility', val: 'hidden', delay: 1000 }
                ],
                destr: [
                    { id: 'tbl-1-1', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-1-0', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-1-2', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'smbl-6', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'txt-2', attr: 'visibility', val: 'hidden', delay: 0 }
                ]
            },
            {
                constr: [
                    { id: 'txt-3', attr: 'visibility', val: 'visible', delay: 400 },
                    { id: 'area', attr: 'visibility', val: 'visible', delay: 1000 },
                    { id: 'line', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'area', attr: 'visibility', val: 'hidden', delay: 1000 },
                    { id: 'line', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'area', attr: 'visibility', val: 'visible', delay: 1000 },
                    { id: 'line', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'area', attr: 'visibility', val: 'hidden', delay: 1000 },
                    { id: 'line', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'txt-3', attr: 'visibility', val: 'hidden', delay: 1000 }
                ],
                destr: [
                    { id: 'area', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'line', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'txt-3', attr: 'visibility', val: 'hidden', delay: 0 }
                ]
            },
            {
                constr: [
                    { id: 'txt-4', attr: 'visibility', val: 'visible', delay: 400 },
                    { id: 'errorbar-1', attr: 'visibility', val: 'visible', delay: 1000 },
                    { id: 'errorbar-2', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'errorbar-3', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'errorbar-4', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'errorbar-1', attr: 'visibility', val: 'hidden', delay: 1000 },
                    { id: 'errorbar-2', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'errorbar-3', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'errorbar-4', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'errorbar-1', attr: 'visibility', val: 'visible', delay: 1000 },
                    { id: 'errorbar-2', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'errorbar-3', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'errorbar-4', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'errorbar-1', attr: 'visibility', val: 'hidden', delay: 1000 },
                    { id: 'errorbar-2', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'errorbar-3', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'errorbar-4', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'txt-4', attr: 'visibility', val: 'hidden', delay: 1000 }
                ],
                destr: [
                    { id: 'errorbar-1', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'errorbar-2', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'errorbar-3', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'errorbar-4', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'txt-4', attr: 'visibility', val: 'hidden', delay: 0 }
                ]
            },
            {
                constr: [
                    { id: 'txt-5', attr: 'visibility', val: 'visible', delay: 400 },
                    { id: 'smbl-14', attr: 'visibility', val: 'visible', delay: 1000 },
                    { id: 'smbl-15', attr: 'visibility', val: 'visible', delay: 0 },
                    { id: 'zoombox', attr: 'visibility', val: 'visible', delay: 1000 },
                    { id: 'zoombox', attr: 'visibility', val: 'hidden', delay: 500 },
                    { id: 'zoombox', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'zoombox', attr: 'visibility', val: 'hidden', delay: 500 },
                    { id: 'zoombox', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'zoombox', attr: 'visibility', val: 'hidden', delay: 500 },
                    { id: 'zoombox', attr: 'visibility', val: 'visible', delay: 500 },
                    { class: 'smbl', attr: 'visibility', val: 'hidden', delay: 3000 },
                    { class: 'smbl-2', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'zoombox', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl-3', attr: 'visibility', val: 'visible', delay: 0 },
                    { id: 'zoombox-3', attr: 'visibility', val: 'visible', delay: 0 },
                    { id: 'zoombox-3', attr: 'visibility', val: 'hidden', delay: 500 },
                    { id: 'zoombox-3', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'zoombox-3', attr: 'visibility', val: 'hidden', delay: 500 },
                    { id: 'zoombox-3', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'zoombox-3', attr: 'visibility', val: 'hidden', delay: 500 },
                    { id: 'zoombox-3', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'zoombox-3', attr: 'visibility', val: 'hidden', delay: 3000 },
                    { class: 'smbl-3', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'zoombox-3', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl', attr: 'visibility', val: 'visible', delay: 0 },
                    { id: 'txt-5', attr: 'visibility', val: 'hidden', delay: 1000 }
                ],
                destr: [
                    { id: 'txt-5', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl', attr: 'visibility', val: 'visible', delay: 0 },
                    { class: 'smbl-2', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl-3', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'zoombox', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'zoombox-3', attr: 'visibility', val: 'hidden', delay: 0 }
                ]
            },
            {
                constr: [
                    { id: 'txt-6', attr: 'visibility', val: 'visible', delay: 400 },
                    { id: 'tbl-0-0', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-1-0', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-2-0', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-3-0', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-0-0', attr: 'fill', val: 'white', delay: 500 },
                    { id: 'tbl-1-0', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-2-0', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-3-0', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-0-0', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-1-0', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-2-0', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-3-0', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-0-1', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-1-1', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-2-1', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-3-1', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-0-1', attr: 'fill', val: 'white', delay: 500 },
                    { id: 'tbl-1-1', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-2-1', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-3-1', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-0-1', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-1-1', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-2-1', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-3-1', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-0-2', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-1-2', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-2-2', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-3-2', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-0-2', attr: 'fill', val: 'white', delay: 500 },
                    { id: 'tbl-1-2', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-2-2', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-3-2', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'tbl-0-2', attr: 'fill', val: 'crimson', delay: 500 },
                    { id: 'tbl-1-2', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-2-2', attr: 'fill', val: 'crimson', delay: 0 },
                    { id: 'tbl-3-2', attr: 'fill', val: 'crimson', delay: 0 },
                    { class: 'tblcell', attr: 'fill', val: 'white', delay: 500 },
                    { id: 'txt-6', attr: 'visibility', val: 'hidden', delay: 1000 }
                ],
                destr: [
                    { class: 'tblcell', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'txt-6', attr: 'visibility', val: 'hidden', delay: 0 }
                ]
            },
            {
                constr: [
                    { id: 'txt-7', attr: 'visibility', val: 'visible', delay: 400 },
                    { id: 'tbl-large-0', attr: 'visibility', val: 'visible', delay: 1000 },
                    { id: 'tbl-large-1', attr: 'visibility', val: 'visible', delay: 0 },
                    { id: 'tbl-large-2', attr: 'visibility', val: 'visible', delay: 0 },
                    { class: 'smbl-4', attr: 'visibility', val: 'visible', delay: 1000 },
                    { class: 'smbl-5', attr: 'visibility', val: 'visible', delay: 500 },
                    { class: 'smbl-6', attr: 'visibility', val: 'visible', delay: 500 },
                    { class: 'smbl-7', attr: 'visibility', val: 'visible', delay: 500 },
                    { id: 'tbl-large-0', attr: 'visibility', val: 'hidden', delay: 3000 },
                    { id: 'tbl-large-1', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'tbl-large-2', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl-4', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl-5', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl-6', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl-7', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'txt-7', attr: 'visibility', val: 'hidden', delay: 1000 }
                ],
                destr: [
                    { id: 'txt-7', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'tbl-large-0', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'tbl-large-1', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'tbl-large-2', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl-4', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl-5', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl-6', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl-7', attr: 'visibility', val: 'hidden', delay: 0 }
                ]
            },
            {
                constr: [
                    { id: 'txt-8', attr: 'visibility', val: 'visible', delay: 400 },

                    { class: 'tblcell', attr: 'height', val: 2 * hlp.rowHeight, delay: 1000 },
                    { class: 'tblcell', attr: 'fill', val: 'khaki', delay: 0 },
                    { class: 'smbl', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl-8', attr: 'visibility', val: 'visible', delay: 0 },

                    { id: 'leftbg', attr: 'fill', val: 'white', delay: 2000 },
                    { id: 'rightbg', attr: 'fill', val: 'white', delay: 0 },
                    { id: 'vertspl', attr: 'fill', val: 'darkgray', delay: 0 },
                    { class: 'tblcell', attr: 'height', val: 3, delay: 0 },
                    { class: 'tblcell', attr: 'fill', val: 'dimgray', delay: 0 },
                    { class: 'tblcell', attr: 'filter', val: 'none', delay: 0 },
                    { class: 'smbl-8', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl-9', attr: 'visibility', val: 'visible', delay: 0 },

                    { id: 'leftbg', attr: 'fill', val: '#a9c3cf', delay: 2000 },
                    { id: 'rightbg', attr: 'fill', val: '#6395ed', delay: 0 },
                    { id: 'vertspl', attr: 'fill', val: 'white', delay: 0 },
                    { class: 'tblcell', attr: 'height', val: hlp.rowHeight, delay: 0 },
                    { class: 'tblcell', attr: 'fill', val: 'white', delay: 0 },
                    { class: 'tblcell', attr: 'filter', val: 'url(#filter_logo)', delay: 0 },
                    { class: 'smbl-9', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl', attr: 'visibility', val: 'visible', delay: 0 },
                    { id: 'txt-8', attr: 'visibility', val: 'hidden', delay: 1000 }
                ],
                destr: [
                    { id: 'txt-8', attr: 'visibility', val: 'hidden', delay: 0 },
                    { id: 'leftbg', attr: 'fill', val: '#a9c3cf', delay: 0 },
                    { id: 'rightbg', attr: 'fill', val: '#6395ed', delay: 0 },
                    { id: 'vertspl', attr: 'fill', val: 'white', delay: 0 },
                    { class: 'tblcell', attr: 'height', val: hlp.rowHeight, delay: 0 },
                    { class: 'tblcell', attr: 'fill', val: 'white', delay: 0 },
                    { class: 'tblcell', attr: 'filter', val: 'url(#filter_logo)', delay: 0 },
                    { class: 'smbl-8', attr: 'visibility', val: 'hidden', delay: 0 },
                    { class: 'smbl', attr: 'visibility', val: 'visible', delay: 0 }
                ]
            }
        ];
    };

    hlp.procSeqStep = function (step) {

        if (typeof step.class === 'string') {
            var elems = document.getElementsByClassName(step.class);
            for (var e = 0; e < elems.length; e++) {
                elems[e].setAttributeNS(null, step.attr, step.val);
            }
        } else if (typeof step.id === 'string') {
            var elem = document.getElementById(step.id);
            if (elem) {
                elem.setAttributeNS(null, step.attr, step.val);
            }
        }
    };

    hlp.animate = function (nextStep) {

        if (!hlp.anims) {
            hlp.initAnims();
        }

        // cancel
        if (hlp.cancel) {
            hlp.cancel = false;
            hlp.restore(0);
            return;
        }
        hlp.animating = true;
        hlp.cancel = false;

        // animate
        if (hlp.curAnim < 0 || hlp.curAnim >= hlp.anims.length) {
            hlp.animating = false;
            return;
        }
        var sequency = hlp.anims[hlp.curAnim].constr;

        if (nextStep < 0 || nextStep >= sequency.length) {
            return;
        }

        // logo caption
        document.getElementById('logo-caption-' + hlp.curAnim).classList.add('cnActiveLogoCapt');

        (function (nextStep) {
            setTimeout(function () {
                // process the step
                hlp.procSeqStep(sequency[nextStep]);
                // next step
                if (nextStep + 1 >= sequency.length) {
                    document.getElementById('logo-caption-' + hlp.curAnim).classList.remove('cnActiveLogoCapt'); // logo caption
                    hlp.animating = false;
                    if (typeof hlp.onready === 'function') {
                        hlp.onready();
                        hlp.onready = function () { };
                    } else {
                        hlp.curAnim++;
                        hlp.animate(0);
                    }
                    return;
                }
                hlp.animate(nextStep + 1);
            }, sequency[nextStep].delay);
        })(nextStep);
    };

    hlp.restore = function (nextStep) {

        if (hlp.curAnim < 0 || hlp.curAnim >= hlp.anims.length) {
            return;
        }
        var sequency = hlp.anims[hlp.curAnim].destr;
        if (nextStep < 0 || nextStep >= sequency.length) {
            return;
        }

        (function (nextStep) {
            setTimeout(function () {
                // process the step
                hlp.procSeqStep(sequency[nextStep]);
                // next step
                if (nextStep + 1 >= sequency.length) {
                    document.getElementById('logo-caption-' + hlp.curAnim).classList.remove('cnActiveLogoCapt'); // logo caption
                    hlp.animating = false;
                    if (typeof hlp.onready === 'function') {
                        hlp.onready();
                        hlp.onready = function () { };
                    }
                    return;
                }
                hlp.restore(nextStep + 1);
            }, sequency[nextStep].delay);
        })(nextStep);
    };

    hlp.clickLogoLink = function (mode) {

        if (!hlp.animating) {
            hlp.curAnim = mode;
            hlp.animate(0);
            hlp.onready = function () { };
        } else {
            hlp.cancel = true;
            hlp.onready = function () {
                hlp.curAnim = mode;
                hlp.animate(0);
            };
        }
    };

    hlp.showLogo = function () {

        var nsSvg = 'http://www.w3.org/2000/svg',
            id = 'logo',
            params = { width: 250, height: 250, lineCnt: 4, colCnt: 3, topHeight: 0.18 * 250, offsetX: 2, offsetY: 2 },
            width = Math.round(params.width),
            height = Math.round(params.height),
            stdDev = typeof params.stdDev === 'string' ? params.stdDev : '1 1',
            offsetX = Math.round(typeof params.offsetX === 'number' ? params.offsetX : 6 / 400 * width),
            offsetY = Math.round(typeof params.offsetY === 'number' ? params.offsetY : 6 / 400 * height),
            topHeight = Math.round(typeof params.topHeight === 'number' ? params.topHeight : 64 / 256 * height),
            fontSize = Math.round(typeof params.fontSize === 'number' ? params.fontSize : 0.5 * topHeight),
            fontSizeS = Math.round(typeof params.fontSizeS === 'number' ? params.fontSizeS : 0.35 * topHeight),
            lineW = Math.round(typeof params.lineWidth === 'number' ? params.lineWidth : 4 / 256 * width),
            rowHeight = Math.round(typeof params.rowHeight === 'number' ? params.rowHeight : lineW),
            symbolSize = Math.round(typeof params.symbolSize === 'number' ? params.symbolSize : 2 * lineW),
            lineCnt = Math.round(params.lineCnt || 5),
            colCnt = Math.round(params.colCnt || 2),
            colL, filter, svg, cont, el, el1, el2, h1, x, y, x1, y1, x2, symbols, selSmbls, pnts, points, points2, errorBarPnts, i, j,
            plotX, plotY, plotW, plotH;

        // svg element
        svg = document.getElementById(id);
        svg.setAttributeNS(null, 'width', width);
        svg.setAttributeNS(null, 'height', height);
        svg.setAttribute('xmlns', 'http://www.w3.org/2000/svg');
        svg.setAttribute('version', '1.1');

        // adjust the shadow filter
        filter = document.getElementById('dropShadow-GaussianBlur');
        filter.setAttributeNS(null, 'stdDeviation', stdDev);
        filter = document.getElementById('dropShadow-Offset');
        filter.setAttributeNS(null, 'dx', offsetX);
        filter.setAttributeNS(null, 'dy', offsetY);
        filter = document.getElementById('dropShadow');
        filter = filter.cloneNode(true);
        filter.id = 'filter_' + id;
        document.getElementById('svgDefs').appendChild(filter);

        // rename old container
        cont = document.getElementById('cont');
        if (cont) {
            cont.setAttribute('id', 'cont-old');
        }
        cont.parentNode.removeChild(cont);

        // container
        cont = document.createElementNS(nsSvg, 'g');
        svg.appendChild(cont);
        cont.setAttribute('id', 'cont');

        // background
        el = document.createElementNS(nsSvg, 'rect');
        cont.appendChild(el);
        el.setAttributeNS(null, 'width', width);
        el.setAttributeNS(null, 'height', height);
        el.setAttributeNS(null, 'fill', '#6d8c99');

        // white central part
        el = document.createElementNS(nsSvg, 'rect');
        cont.appendChild(el);
        el.setAttributeNS(null, 'width', width);
        h1 = height - 2 * topHeight;
        el.setAttributeNS(null, 'height', h1 - 2 * lineW);
        y1 = topHeight + lineW;
        el.setAttributeNS(null, 'y', y1);
        el.setAttributeNS(null, 'shape-rendering', 'crispEdges');
        el.setAttributeNS(null, 'fill', '#ffffff');

        // left side
        el1 = document.createElementNS(nsSvg, 'rect');
        el1.setAttribute('id', 'leftbg');
        cont.appendChild(el1);
        el1.setAttributeNS(null, 'width', width / 2);
        el1.setAttributeNS(null, 'height', h1 - 2 * lineW);
        el1.setAttributeNS(null, 'y', y1);
        el1.setAttributeNS(null, 'shape-rendering', 'crispEdges');
        el1.setAttributeNS(null, 'fill', '#a9c3cf');

        // right side
        el2 = document.createElementNS(nsSvg, 'rect');
        el2.setAttribute('id', 'rightbg');
        cont.appendChild(el2);
        el2.setAttributeNS(null, 'width', el1.getAttributeNS(null, 'width'));
        el2.setAttributeNS(null, 'height', el1.getAttributeNS(null, 'height'));
        el2.setAttributeNS(null, 'x', width - el2.getAttributeNS(null, 'width'));
        el2.setAttributeNS(null, 'y', y1);
        el2.setAttributeNS(null, 'shape-rendering', 'crispEdges');
        el2.setAttributeNS(null, 'fill', '#6395ed');

        // vertical splitter
        el = document.createElementNS(nsSvg, 'rect');
        el.setAttribute('id', 'vertspl');
        cont.appendChild(el);
        el.setAttributeNS(null, 'x', width / 2 - lineW / 2);
        el.setAttributeNS(null, 'y', topHeight);
        el.setAttributeNS(null, 'width', lineW);
        el.setAttributeNS(null, 'height', height - 2 * topHeight);
        el.setAttributeNS(null, 'shape-rendering', 'crispEdges');
        el.setAttributeNS(null, 'fill', '#ffffff');

        // upper horizontal splitter
        el = document.createElementNS(nsSvg, 'rect');
        cont.appendChild(el);
        el.setAttributeNS(null, 'x', 0);
        el.setAttributeNS(null, 'y', topHeight);
        el.setAttributeNS(null, 'width', width);
        el.setAttributeNS(null, 'height', lineW);
        el.setAttributeNS(null, 'shape-rendering', 'crispEdges');
        el.setAttributeNS(null, 'fill', '#ffffff');

        // lower horizontal splitter
        el = document.createElementNS(nsSvg, 'rect');
        cont.appendChild(el);
        el.setAttributeNS(null, 'x', 0);
        el.setAttributeNS(null, 'y', height - topHeight - lineW);
        el.setAttributeNS(null, 'width', width);
        el.setAttributeNS(null, 'height', lineW);
        el.setAttributeNS(null, 'shape-rendering', 'crispEdges');
        el.setAttributeNS(null, 'fill', '#ffffff');
        el.setAttributeNS(null, 'filter', 'url(#' + filter.id + ')');

        // upper text
        hlp.createText('txt-1-1', cont, 'Simple: Drop a data file', width, 10, 0, topHeight, fontSizeS, 400, undefined);
        hlp.createText('txt-1-2', cont, 'and select variables', width, 10, 0, topHeight, fontSizeS, 400, undefined);
        hlp.createText('txt-2', cont, 'Cross-linked charts and tables', width, 10, 0, topHeight, fontSizeS, 400, undefined);
        hlp.createText('txt-3', cont, 'Line, scatter, and area plots', width, 10, 0, topHeight, fontSizeS, 400, undefined);
        hlp.createText('txt-4', cont, 'Error bars', width, 10, 0, topHeight, fontSizeS, 400, undefined);
        hlp.createText('txt-5', cont, 'Zoom-dependent rendering', width, 10, 0, topHeight, fontSizeS, 400, undefined);
        hlp.createText('txt-6', cont, 'Table column data operations', width, 10, 0, topHeight, fontSizeS, 400, undefined);
        hlp.createText('txt-7', cont, 'Large data sets', width, 10, 0, topHeight, fontSizeS, 400, undefined);
        hlp.createText('txt-8', cont, 'Styling', width, 10, 0, topHeight, fontSizeS, 400, undefined);

        // lower text
        hlp.createText('txt-0', cont, 'ExploreTheData', width, undefined, height - topHeight, topHeight, fontSize, 500, filter.id);

        // table
        x1 = 16 / 122 * el1.getAttributeNS(null, 'width');
        x2 = (1 - 16 / 122) * el1.getAttributeNS(null, 'width');
        colL = (x2 - x1 - (colCnt - 1) * lineW) / colCnt;
        for (i = 0; i < lineCnt; i++) {
            x = x1;
            for (j = 0; j < colCnt; j++) {

                el = document.createElementNS(nsSvg, 'rect');
                el.setAttributeNS(null, 'visibility', 'hidden');
                cont.appendChild(el);
                el.setAttribute('class', 'tblcell');
                el.setAttribute('id', 'tbl-' + i + '-' + j);
                el.setAttributeNS(null, 'fill', '#ffffff');
                el.setAttributeNS(null, 'x', x);
                y1 = Math.round((i + 1) * (parseInt(el1.getAttributeNS(null, 'height')) + rowHeight) / (lineCnt + 1) +
                    (el1.getAttributeNS(null, 'y') - rowHeight));
                el.setAttributeNS(null, 'y', y1);
                el.setAttributeNS(null, 'width', colL);
                el.setAttributeNS(null, 'height', rowHeight);
                el.setAttributeNS(null, 'shape-rendering', 'crispEdges');
                el.setAttributeNS(null, 'filter', 'url(#' + filter.id + ')'); // temporarily changed for demo Styling

                if (i === 0 && j === 0) {
                    hlp.rowHeight = rowHeight;
                    hlp.firstRowTop = y1;
                }
                if (i + 1 === lineCnt && j === 0) {
                    hlp.lastRowTop = y1;
                }

                x += colL + lineW;
            }
        }

        // demo large table
        for (j = 0; j < colCnt; j++) {
            el = document.getElementById('tbl-0-' + j);
            var elx = el.cloneNode();
            elx.setAttributeNS(null, 'visibility', 'hidden');
            elx.setAttribute('class', 'tbl-large');
            elx.setAttribute('id', 'tbl-large-' + j);
            elx.setAttributeNS(null, 'height', hlp.lastRowTop + hlp.rowHeight - hlp.firstRowTop);
            cont.appendChild(elx);
        }

        // plot
        var zoom = 5;
        symbols = [{ x: 138, y: 187, fill: '#ffa500' }, { x: 138, y: 167, fill: '#ffffff' }, { x: 171, y: 183, fill: '#ffffff' },
        { x: 150, y: 134, fill: '#ffffff' }, { x: 167, y: 146, fill: '#ffa500' }, { x: 191, y: 171, fill: '#ffffff' },
        { x: 158, y: 106, fill: '#ffffff' }, { x: 195, y: 142, fill: '#ffffff' }, { x: 216, y: 151, fill: '#ffffff' },
        { x: 191, y: 114, fill: '#ffa500' }, { x: 187, y: 82, fill: '#ffffff' }, { x: 211, y: 110, fill: '#ffffff' },
        { x: 224, y: 130, fill: '#ffffff' }, { x: 223, y: 77, fill: '#ffa500' },

        { x: 187 - 6, y: 82 - 6, fill: '#ffffff' }, { x: 187 + 6, y: 82 - 8, fill: '#ffffff' }, // 2 additional symbols for demo of zoom-depending rendering
        { x: 185, y: 150, fill: '#ffffff' }, { x: 185 - zoom * 6, y: 150 - zoom * 6, fill: '#ffffff' }, { x: 185 + zoom * 6, y: 150 - zoom * 8, fill: '#ffffff' } // 3 symbols for demo of zoom-depending rendering, zoomed-in
        ];

        // demo line, scatter, and area plots
        selSmbls = [0, 4, 9, 13], points = '', points2 = '';
        for (i = 0; i < selSmbls.length; i++) {
            x = Math.round(parseInt(el2.getAttributeNS(null, 'x')) + (symbols[selSmbls[i]].x - 126) / 126 * parseInt(el2.getAttributeNS(null, 'width')) + symbolSize / 2);
            if (i === 0) {
                points2 += x + ',' + (height - topHeight - lineW - 1);
            }
            pnts = ' ' + x + ',' +
                Math.round(parseInt(el2.getAttributeNS(null, 'y')) + (symbols[selSmbls[i]].y - 49) / 158 * parseInt(el2.getAttributeNS(null, 'height')) + symbolSize / 2)
            points += pnts;
            points2 += pnts;
            if (i + 1 === selSmbls.length) {
                points2 += ' ' + x + ',' + (height - topHeight - lineW - 1);
            }
        }

        el = document.createElementNS(nsSvg, 'polygon');
        cont.appendChild(el);
        el.setAttribute('id', 'area');
        el.setAttributeNS(null, 'stroke', 'none');
        el.setAttributeNS(null, 'fill', '#ffa500');
        el.setAttributeNS(null, 'fill-opacity', 1);
        el.setAttributeNS(null, 'points', points2);
        el.setAttributeNS(null, 'filter', 'url(#' + filter.id + ')');
        el.setAttributeNS(null, 'visibility', 'hidden');
        /*
        el = document.createElementNS(nsSvg, 'path');
        cont.appendChild(el);
        el.setAttributeNS(null, 'stroke', '#ffa500');
        el.setAttributeNS(null, 'stroke-width', 3);
        el.setAttributeNS(null, 'shape-rendering', 'geometricPrecision');
        el.setAttributeNS(null, 'd', 'M' + points); */
        el = document.createElementNS(nsSvg, 'polyline');
        cont.appendChild(el);
        el.setAttribute('id', 'line');
        el.setAttributeNS(null, 'stroke', '#ffa500');
        el.setAttributeNS(null, 'stroke-width', 3);
        el.setAttributeNS(null, 'shape-rendering', 'geometricPrecision');
        el.setAttributeNS(null, 'points', points);
        el.setAttributeNS(null, 'filter', 'url(#' + filter.id + ')');
        el.setAttributeNS(null, 'visibility', 'hidden');

        // demo error bars
        selSmbls = [0, 4, 9, 13];
        errorBarPnts = [];
        for (i = 0; i < selSmbls.length; i++) {
            x = Math.round(parseInt(el2.getAttributeNS(null, 'x')) + (symbols[selSmbls[i]].x - 126) / 126 * parseInt(el2.getAttributeNS(null, 'width')) + symbolSize / 2);
            y = Math.round(parseInt(el2.getAttributeNS(null, 'y')) + (symbols[selSmbls[i]].y - 49) / 158 * parseInt(el2.getAttributeNS(null, 'height')) + symbolSize / 2);
            errorBarPnts.push({ x1: x, y1: y - (i > 0 ? 18 : 12), x2: x, y2: y + (i > 0 ? 18 : 12) });
        }

        for (i = 0; i < errorBarPnts.length; i++) {
            el = document.createElementNS(nsSvg, 'line');
            cont.appendChild(el);
            el.setAttribute('id', 'errorbar-' + (i + 1));
            el.setAttributeNS(null, 'stroke', '#ffa500');
            el.setAttributeNS(null, 'stroke-width', 3);
            el.setAttributeNS(null, 'shape-rendering', 'geometricPrecision');
            el.setAttributeNS(null, 'x1', errorBarPnts[i].x1);
            el.setAttributeNS(null, 'y1', errorBarPnts[i].y1);
            el.setAttributeNS(null, 'x2', errorBarPnts[i].x2);
            el.setAttributeNS(null, 'y2', errorBarPnts[i].y2);
            el.setAttributeNS(null, 'filter', 'url(#' + filter.id + ')');
            el.setAttributeNS(null, 'visibility', 'hidden');
        }

        // all data symbols
        plotX = parseInt(el2.getAttributeNS(null, 'x'));
        plotY = parseInt(el2.getAttributeNS(null, 'y'));
        plotW = parseInt(el2.getAttributeNS(null, 'width'));
        plotH = parseInt(el2.getAttributeNS(null, 'height'));
        for (i = 0; i < symbols.length; i++) {
            el = document.createElementNS(nsSvg, 'rect');
            el.setAttributeNS(null, 'visibility', 'hidden');
            cont.appendChild(el);
            el.setAttribute('class', 'smbl');
            el.setAttribute('id', 'smbl-' + i);
            x = plotX + (symbols[i].x - 126) / 126 * plotW;
            el.setAttributeNS(null, 'x', x);
            y = plotY + (symbols[i].y - 49) / 158 * plotH;
            el.setAttributeNS(null, 'y', y);
            el.setAttributeNS(null, 'width', symbolSize);
            el.setAttributeNS(null, 'height', symbolSize);
            el.setAttributeNS(null, 'fill', symbols[i].fill);
            el.setAttributeNS(null, 'shape-rendering', 'crispEdges');
            el.setAttributeNS(null, 'filter', 'url(#' + filter.id + ')');

            // demo zoom - dependent rendering
            if (i === 14 || i === 15) { // demo zoom-dependent rendering, zoom = 1
                el.setAttribute('class', 'smbl-2');
            } else if (i === 16 || i === 17 || i === 18) { // demo zoom-dependent rendering, zoom > 1
                el.setAttribute('class', 'smbl-3');
            }

            // demo styling
            if (el.getAttribute('class') === 'smbl') {

                el = document.createElementNS(nsSvg, 'circle');
                el.setAttributeNS(null, 'visibility', 'hidden');
                cont.appendChild(el);
                el.setAttribute('class', 'smbl-8');
                el.setAttributeNS(null, 'cx', x + symbolSize/2);
                el.setAttributeNS(null, 'cy', y + symbolSize/2);
                el.setAttributeNS(null, 'r', symbolSize / 2);
                if (symbols[i].fill === '#ffffff') {
                    el.setAttributeNS(null, 'fill', 'crimson');
                } else {
                    el.setAttributeNS(null, 'fill', 'limegreen');
                }
                el.setAttributeNS(null, 'stroke', 'white');
                el.setAttributeNS(null, 'stroke-width', 2);
                el.setAttributeNS(null, 'filter', 'url(#' + filter.id + ')');

                el = document.createElementNS(nsSvg, 'use');
                if (symbols[i].fill === '#ffffff') {
                    el.setAttributeNS('http://www.w3.org/1999/xlink', 'xlink:href', '#c-triangle-8m');
                } else {
                    el.setAttributeNS('http://www.w3.org/1999/xlink', 'xlink:href', '#c-plus-10m');
                }
                el.setAttributeNS(null, 'visibility', 'hidden');
                cont.appendChild(el);
                el.setAttribute('class', 'smbl-9');
                el.setAttributeNS(null, 'x', x + symbolSize / 2);
                el.setAttributeNS(null, 'y', y + symbolSize / 2);
                //el.setAttributeNS(null, 'filter', 'url(#' + filter.id + ')');
            }
        }

        // demo zoom-dependent rendering, zoom = 1
        el = document.createElementNS(nsSvg, 'rect');
        el.setAttributeNS(null, 'visibility', 'hidden');
        cont.appendChild(el);
        el.setAttribute('id', 'zoombox');
        el.setAttributeNS(null, 'x', 169);
        el.setAttributeNS(null, 'y', 62);
        el.setAttributeNS(null, 'width', 40);
        el.setAttributeNS(null, 'height', 40);
        el.setAttributeNS(null, 'fill', 'aqua');
        el.setAttributeNS(null, 'fill-opacity', 0.2);
        el.setAttributeNS(null, 'stroke', 'aqua');
        el.setAttributeNS(null, 'stroke-width', 1);

        // demo zoom-dependent rendering, zoom > 1
        el = el.cloneNode();
        cont.appendChild(el);
        el.setAttribute('id', 'zoombox-3');
        el.setAttributeNS(null, 'x', 145);
        el.setAttributeNS(null, 'y', 80);
        el.setAttributeNS(null, 'width', 90);
        el.setAttributeNS(null, 'height', 90);

        // demo plot with a large number of data symbols
        plotX = parseInt(el2.getAttributeNS(null, 'x'));
        plotY = parseInt(el2.getAttributeNS(null, 'y'));
        plotW = parseInt(el2.getAttributeNS(null, 'width'));
        plotH = parseInt(el2.getAttributeNS(null, 'height'));
        for (i = 0; i < symbols.length; i++) {
            for (j = 0; j < 4; j++) {
                el = document.createElementNS(nsSvg, 'rect');
                el.setAttributeNS(null, 'visibility', 'hidden');
                cont.appendChild(el);
                el.setAttribute('class', 'smbl-' + (4 + j));
                el.setAttributeNS(null, 'x', plotX + (symbols[i].x - 126) / 126 * plotW + (Math.random() - 0.5) * 25);
                el.setAttributeNS(null, 'y', plotY + (symbols[i].y - 49) / 158 * plotH + (Math.random() - 0.5) * 25);
                el.setAttributeNS(null, 'width', symbolSize);
                el.setAttributeNS(null, 'height', symbolSize);
                el.setAttributeNS(null, 'fill', symbols[i].fill);
                el.setAttributeNS(null, 'shape-rendering', 'crispEdges');
                el.setAttributeNS(null, 'filter', 'url(#' + filter.id + ')');
            }
        }

        // animate
        hlp.animate(0);
    };

    hlp.createText = function (id, parent, text, parentWidth, x, parentTop, parentHeight, fontSize, fontWeight, filterID) {
        var nsSvg = 'http://www.w3.org/2000/svg',
            domTxtN, domTxt, bbox;

        if (fontSize <= 0) {
            return;
        }

        domTxtN = document.createTextNode(text);
        domTxt = document.createElementNS(nsSvg, 'text');
        domTxt.setAttribute('id', id);
        domTxt.setAttributeNS(null, 'font-family', '"Segoe UI", "Segoe WP", "Arial", sans-serif');
        domTxt.setAttributeNS(null, 'font-weight', 'normal');
        domTxt.setAttributeNS(null, 'font-weight', fontWeight);
        domTxt.setAttributeNS(null, 'font-size', Math.round(fontSize));
        domTxt.setAttributeNS(null, 'fill', '#ffffff');
        domTxt.setAttributeNS(null, 'text-rendering', 'optimizeLegibility');
        domTxt.setAttributeNS(null, 'visibility', 'hidden');
        if (filterID) {
            domTxt.setAttributeNS(null, 'filter', 'url(#' + filterID + ')');
        }
        domTxt.appendChild(domTxtN);
        parent.appendChild(domTxt);
        // align
        bbox = domTxt.getBBox();
        if (typeof x === 'number') {
            domTxt.setAttributeNS(null, 'x', x);
        } else {
            domTxt.setAttributeNS(null, 'x', -bbox.x + (parentWidth - bbox.width) / 2);
        }
        domTxt.setAttributeNS(null, 'y', parentTop - bbox.y + (parentHeight - bbox.height) / 2);
        return domTxt;
    };
})(help);
